using System;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using Microsoft.Practices.EnterpriseLibrary.Caching;
using Microsoft.Practices.EnterpriseLibrary.Caching.Expirations;
using System.Threading;
using System.IO;


namespace CachingThreadWaitTests
{
    /// <summary>
    /// Summary description for MultipleThreadBehaviourThreadFixture
    /// </summary>
    [TestClass]
    public class MultipleThreadBehaviourTestFixture
    {
        public CacheManager itemCache;
        int i;
        int index = 0;
        int removeIndex = 0;
        int noOfThreads = 100;
        public MultipleThreadBehaviourTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        /// Initialize() is called once during test execution before
        /// test methods in this test class are executed.
        /// </summary>
        [TestInitialize()]
        public void Initialize()
        {
            itemCache = CacheFactory.GetCacheManager("MultiThreadCacheManager");
            if (itemCache != null)
                itemCache.Flush();           
        }

        /// <summary>
        /// Cleanup() is called once during test execution after
        /// test methods in this class have executed unless the
        /// corresponding Initialize() call threw an exception.
        /// </summary>
        [TestCleanup()]
        public void Cleanup()
        {
            //  TODO: Add test cleanup code
        }
        #region "Multithread"

        [TestMethod]
        public void ItemsAddTest()
        {
            CacheManager itemCache = CacheFactory.GetCacheManager("MultiThreadCacheManager");
            if (itemCache != null)
                itemCache.Flush();

            itemCache = CacheFactory.GetCacheManager("MultiThreadCacheManager");

           for (int i = 0; i < 1500; i++)
                itemCache.Add(i.ToString(), i);


        }
        [TestMethod]
        public void MutipleThreadAddTest()
        {
            ItemDetails writtenItem = new ItemDetails();
            index = 0;
            Thread[] exThread = new Thread[noOfThreads];
            for (i = 0; i < noOfThreads; i++)
            {
                exThread[i] = new Thread(new ThreadStart(AddingItems));
                exThread[i].IsBackground = true;
                exThread[i].Name = (i + 1).ToString();
                exThread[i].Start();
            }
            while (index != noOfThreads)
            {
            }

            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 1));
            Assert.AreEqual(noOfThreads + 1, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 2));
            Assert.AreEqual(noOfThreads + 2, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 3));
            Assert.AreEqual(noOfThreads + 3, writtenItem.ItemId);

            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 1));
            Assert.AreEqual(noOfThreads * 2 + 1, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 2));
            Assert.AreEqual(noOfThreads * 2 + 2, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 3));
            Assert.AreEqual(noOfThreads * 2 + 3, writtenItem.ItemId);

            Assert.AreEqual(3 * noOfThreads, itemCache.Count);
        }

        
       


            [TestMethod]
        public void MutipleThreadRemoveTest()
        {
            ItemDetails writtenItem = new ItemDetails();
            index = 0;
            Thread[] exThread = new Thread[noOfThreads];
            Thread[] removeexThread = new Thread[noOfThreads];
            for (i = 0; i < noOfThreads; i++)
            {
                exThread[i] = new Thread(new ThreadStart(AddingItems));
                exThread[i].IsBackground = true;
                exThread[i].Name = (i + 1).ToString();
                exThread[i].Start();
            }

            while (index != noOfThreads)
            {
                }
                writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 1));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 2));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 3));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 1));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 2));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 3));
            Assert.IsNotNull(writtenItem);
            Assert.AreEqual(3*noOfThreads, itemCache.Count);
            removeIndex = 0;
            for (i = 0; i < noOfThreads; i++)
            {
                removeexThread[i] = new Thread(new ThreadStart(RemoveItems));
                removeexThread[i].IsBackground = true;
                removeexThread[i].Name = (i + 1).ToString();
                removeexThread[i].Start();
            }
            while (removeIndex != noOfThreads )
            {
            }

            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 1));
            Assert.IsNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 2));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 3));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 1));
            Assert.IsNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 2));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 3));
            Assert.IsNotNull(writtenItem);
            Assert.AreEqual(2*noOfThreads, itemCache.Count);

        }
            #endregion
       
        #region"Multithread diff overload"
        [TestMethod]
        public void AddwithdiffoverloadThreadTest()
        {
            ItemDetails writtenItem = new ItemDetails();
            index = 0;
            Thread[] exThread = new Thread[noOfThreads];
            for (i = 0; i < noOfThreads; i++)
            {
                exThread[i] = new Thread(new ThreadStart(AddItemswithDiffCombinations));
                exThread[i].IsBackground = true;
                exThread[i].Name = (i + 1).ToString();
                exThread[i].Start();
            }
            while (index != noOfThreads)
            {
            }
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 1));
            Assert.AreEqual(noOfThreads + 1, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 2));
            Assert.AreEqual(noOfThreads + 2, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 3));
            Assert.AreEqual(noOfThreads + 3, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 4));
            Assert.AreEqual(noOfThreads + 4, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 5));
            Assert.AreEqual(noOfThreads + 5, writtenItem.ItemId);

            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 1));
            Assert.AreEqual(noOfThreads * 2 + 1, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 2));
            Assert.AreEqual(noOfThreads * 2 + 2, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 3));
            Assert.AreEqual(noOfThreads * 2 + 3, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 4));
            Assert.AreEqual(noOfThreads * 2 + 4, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 5));
            Assert.AreEqual(noOfThreads * 2 + 5, writtenItem.ItemId);

            Assert.AreEqual(5 * noOfThreads, itemCache.Count);

        }
            
        
        [TestMethod]
        public void RemovewithdiffoverloadThreadTest()
              
        {
            ItemDetails writtenItem = new ItemDetails();
            index = 0;
            Thread[] exThread = new Thread[noOfThreads];
            Thread[] removeexThread = new Thread[noOfThreads];
            for (i = 0; i < noOfThreads; i++)
            {
                exThread[i] = new Thread(new ThreadStart(AddItemswithDiffCombinations));
                exThread[i].IsBackground = true;
                exThread[i].Name = (i + 1).ToString();
                exThread[i].Start();
            }
            while (index != noOfThreads)
            {
            }

            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 1));
            Assert.AreEqual(noOfThreads + 1, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 2));
            Assert.AreEqual(noOfThreads + 2, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 3));
            Assert.AreEqual(noOfThreads + 3, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 4));
            Assert.AreEqual(noOfThreads + 4, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 5));
            Assert.AreEqual(noOfThreads + 5, writtenItem.ItemId);

            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 1));
            Assert.AreEqual(noOfThreads * 2 + 1, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 2));
            Assert.AreEqual(noOfThreads * 2 + 2, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 3));
            Assert.AreEqual(noOfThreads * 2 + 3, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 4));
            Assert.AreEqual(noOfThreads * 2 + 4, writtenItem.ItemId);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 5));
            Assert.AreEqual(noOfThreads * 2 + 5, writtenItem.ItemId);

            Assert.AreEqual(5*noOfThreads, itemCache.Count);

            removeIndex = 0; 
            for (i = 0; i < noOfThreads; i++)
            {
                removeexThread[i] = new Thread(new ThreadStart(RemoveItems));
                removeexThread[i].IsBackground = true;
                removeexThread[i].Name = (i + 1).ToString();
                removeexThread[i].Start();
            }

            while (removeIndex != noOfThreads)
            {
            }
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 1));
            Assert.IsNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 2));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 3));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 4));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads + 5));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 1));
            Assert.IsNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 2));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 3));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 4));
            Assert.IsNotNull(writtenItem);
            writtenItem = (ItemDetails)itemCache.GetData(Convert.ToString(noOfThreads * 2 + 5));
            Assert.IsNotNull(writtenItem);

            Assert.AreEqual(4*noOfThreads, itemCache.Count);

        }
        #endregion

        #region "Multithread with Sliding Expiry"
        [TestMethod]
        public void MutipleThreadAddSlidingExpiryTest()
        {
            ItemDetails writtenItem = new ItemDetails();
            index = 0;
            Thread[] exThread = new Thread[noOfThreads];
            for (i = 0; i < noOfThreads; i++)
            {
                exThread[i] = new Thread(new ThreadStart(AddingItemsSlidingExpiry));
                exThread[i].IsBackground = true;
                exThread[i].Name = (i + 1).ToString();
                exThread[i].Start();
            }

            while (index != noOfThreads)
            {
            }
            
        }
        #endregion

        public void AddingItems()
        {
            ItemDetails additem1 = new ItemDetails((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 1, "one", 100);
            ItemDetails additem2 = new ItemDetails((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 2, "two", 100);
            ItemDetails additem3 = new ItemDetails((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 3, "three", 100);
            itemCache.Add(additem1.ItemId.ToString(), additem1);
            itemCache.Add(additem2.ItemId.ToString(), additem2);
            itemCache.Add(additem3.ItemId.ToString(), additem3);
            index++;
        }
        public void RemoveItems()
        {
            itemCache.Remove(((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 1).ToString());
            removeIndex++;

        }

        public void AddingItemsSlidingExpiry()
        {
            ItemDetails additem = new ItemDetails((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 1, "one", 100);
            itemCache.Add(additem.ItemId.ToString(), additem, CacheItemPriority.High, null, new SlidingTime(TimeSpan.FromSeconds(5)));
            
            index++;

        }
        public void AddItemswithDiffCombinations()
        {
            DateTime newTime = new DateTime();
            DateTime currentTime = DateTime.Now;
            newTime = currentTime.AddMinutes(2);

            ItemDetails itemDetails1 = new ItemDetails((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 1, "one", 100);
            itemCache.Add(itemDetails1.ItemId.ToString(), itemDetails1, CacheItemPriority.Low, null, new SlidingTime(TimeSpan.FromMinutes(2)));

            ItemDetails itemDetails2 = new ItemDetails((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 2, "two", 100);
            itemCache.Add(itemDetails2.ItemId.ToString(), itemDetails2, CacheItemPriority.High, null, new FileDependency("FileForCaching.txt"));
            ItemDetails itemDetails3 = new ItemDetails((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 3, "three", 100);
            itemCache.Add(itemDetails3.ItemId.ToString(), itemDetails3, CacheItemPriority.Normal, null, new ExtendedFormatTime("0 0 * * *"));
            ItemDetails itemDetails4 = new ItemDetails((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 4, "four", 100);
            itemCache.Add(itemDetails4.ItemId.ToString(), itemDetails4, CacheItemPriority.None, null, new AbsoluteTime(newTime));

            ItemDetails itemDetails5 = new ItemDetails((noOfThreads * Convert.ToInt32(Thread.CurrentThread.Name)) + 5, "five", 100);
            itemCache.Add(itemDetails5.ItemId.ToString(), itemDetails5, CacheItemPriority.NotRemovable, null, new SlidingTime(TimeSpan.FromMinutes(2)));
            index++;


        }

    }
}
