using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.ObjectBuilder;  
namespace ConfigurationCoreTests.Configuration
{
    public class CarData:NamedConfigurationElement 
    {
        private const string model = "model";
        private const string brand = "brand";
        private const string carParts = "CarParts";

        public CarData() : base() { }

        public CarData(string name) : base(name) { }

        public CarData(string name, string brand, string model, CarPartsData parts)
            : base(name)
        {
            this.Brand = brand;
            this.Model = model;
        }

        [ConfigurationProperty("model", IsRequired = true)]
        public string Model
        {
            get
            {
                return (string)this[model];
            }
            set
            {
                this[model] = value;
            }
        }

        [ConfigurationProperty("brand", IsRequired = true)]
        public string Brand
        {
            get
            {
                return (string)this[brand];
            }
            set
            {
                this[brand] = value;
            }
        }

        [ConfigurationProperty("CarParts", IsRequired = true)]
        public CarPartsData CarParts
        {
            get
            {
                return (CarPartsData)this[carParts];
            }
            set
            {
                this[carParts] = value;
            }
        }

    }
}
