using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.ObjectBuilder;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using ConfigurationCoreTests.Configuration; 
namespace ConfigurationCoreTests
{
    class CarManagerCustomFactory:ICustomFactory 
    {
        public object CreateObject(IBuilderContext context, string name, IConfigurationSource configurationSource, ConfigurationReflectionCache reflectionCache)
        {
            CarSettings setting = (CarSettings)configurationSource.GetSection("carConfiguration");
            CarData carData = setting.Car;
            Car obj = new Car(carData.CarParts, carData.Model, carData.Brand);
            if (context.Locator != null)
            {
                ILifetimeContainer lifetime = context.Locator.Get<ILifetimeContainer>(typeof(ILifetimeContainer), SearchMode.Local);
                if (lifetime != null)
                {
                    context.Locator.Add(new DependencyResolutionLocatorKey(typeof(Car), name), obj);
                    lifetime.Add(obj);
                }
            }
            return obj;
        }
    }
}
