@echo off
@REM  ----------------------------------------------------------------------------
@REM  SetupTestDB.bat file
@REM
$REM  Sets up the Test database which functional tests for Data block for Enterprise Library 2.0 depend on.
@REM  The test Database is a copy of the quickstarts database with required modifications.
@REM  ----------------------------------------------------------------------------

echo.
echo =========================================================
echo   SetupTestDB
echo      Creates the tables required for the Data Access
echo      QuickStart. The tables are created in the database
echo      EntLibQuickStarts. The script will create the 
echo      database if it does not exist.                           
echo =========================================================
echo.

set pause=true

if "%1"=="/?" goto HELP

if not Exist TestDatabase.sql goto HELPSCRIPT

@REM  ----------------------------------------------------
@REM  If the first parameter is /q, do not pause
@REM  at the end of execution.
@REM  ----------------------------------------------------

if /i "%1"=="/q" (
 set pause=false
)

@REM  ------------------------------------------------
@REM  Shorten the command prompt for making the output
@REM  easier to read.
@REM  ------------------------------------------------
set savedPrompt=%prompt%
set prompt=*$g

@ECHO ----------------------------------------
@ECHO SetupTestDB.bat Started
@ECHO ----------------------------------------
@ECHO.

OSQL -S (local)\SQLEXPRESS  -E -i TestDatabase.sql

@ECHO.
@ECHO ----------------------------------------
@ECHO SetupTestDB.bat Completed
@ECHO ----------------------------------------
@ECHO.

@REM  ----------------------------------------
@REM  Restore the command prompt and exit
@REM  ----------------------------------------
@goto :exit

@REM  -------------------------------------------
@REM  Handle errors
@REM
@REM  Use the following after any call to exit
@REM  and return an error code when errors occur
@REM
@REM  if errorlevel 1 goto :error	
@REM  -------------------------------------------
:error
@ECHO An error occured in SetupTestDB.bat - %errorLevel%
if %pause%==true PAUSE
@exit errorLevel

:HELPSCRIPT
echo Error: Unable to locate the required SQL script TestDatabase.sql
echo.
goto exit

:HELP
echo Usage: SetupTestDB.bat 
echo.

@REM  ----------------------------------------
@REM  The exit label
@REM  ----------------------------------------
:exit
if %pause%==true PAUSE

set pause=
set prompt=%savedPrompt%
set savedPrompt=

echo on

