using System;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using System.Threading;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling;

namespace ExceptionHandlingCoreTests
{
    /// <summary>
    /// Summary description for ExceptionThreadingTestFixture
    /// </summary>
    [TestClass]
    public class ExceptionThreadingTestFixture
    {
        bool threadComplete;
        int count = 0;
        int noOfThreads = 100;
        public ExceptionThreadingTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        /// Initialize() is called once during test execution before
        /// test methods in this test class are executed.
        /// </summary>
        [TestInitialize()]
        public void Initialize()
        {
            //  TODO: Add test initialization code
        }

        /// <summary>
        /// Cleanup() is called once during test execution after
        /// test methods in this class have executed unless the
        /// corresponding Initialize() call threw an exception.
        /// </summary>
        [TestCleanup()]
        public void Cleanup()
        {
            //  TODO: Add test cleanup code
        }

        [TestMethod]
        public void MutipleThreadTest()
        {
            count = 0;
            threadComplete = false;
            Thread[] exThread = new Thread[noOfThreads];
            for (int i = 0; i < noOfThreads; i++)
            {
                exThread[i] = new Thread(new ThreadStart(RaiseException));
                exThread[i].IsBackground = true;
                exThread[i].Name = (i + 1).ToString();
                exThread[i].Start();
            }
            int timeoutCount = 100;
            bool loopTimed = false;
            int index = 0;
            while (!threadComplete || (loopTimed == false))
            {

                Thread.Sleep(100);
                index++;
                if (index == timeoutCount)
                {
                    loopTimed = true;
                }
            }
            Assert.AreEqual(true, threadComplete);
            Assert.AreEqual(noOfThreads, count);
        }

        public void RaiseMultipleException()
        {
            Exception originalException = new System.IO.FileNotFoundException("Original Exception: File Not Found Exception");
            bool rethrow = ExceptionPolicy.HandleException(originalException, "Replace Multiple Exception Types None Action");

            Assert.IsFalse(rethrow);
            rethrow = false;
            originalException = new System.Data.StrongTypingException("Original Exception: Strong Typing Exception");
            rethrow = ExceptionPolicy.HandleException(originalException, "Replace Multiple Exception Types None Action");

            Assert.IsFalse(rethrow);

            threadComplete = true;
            count++;

        }


        [TestMethod]
        public void MutipleThreadMultipleExTypesTest()
        {
            count = 0;
            threadComplete = false;
            Thread[] exThread = new Thread[noOfThreads];
            for (int i = 0; i < noOfThreads; i++)
            {
                exThread[i] = new Thread(new ThreadStart(RaiseMultipleException));
                exThread[i].IsBackground = true;
                exThread[i].Name = (i + 1).ToString();
                exThread[i].Start();
            }
            int timeoutCount = 100;
            int index = 0;
            bool loopTimed = false;
            while (!threadComplete || (loopTimed == false))
            {

                Thread.Sleep(100);
                index++;
                if (index == timeoutCount)
                {
                    loopTimed = true;
                }
            }
            Assert.AreEqual(true, threadComplete);
            Assert.AreEqual(noOfThreads, count);
        }


        public void RaiseException()
        {
            Exception originalException = new System.Security.SecurityException("Original Exception: Security Exception");
            bool rethrow = ExceptionPolicy.HandleException(originalException, "Replace with None");

            Assert.IsFalse(rethrow);

            threadComplete = true;
            count++;

        }
    }


}
