using System;
using System.Text;
using System.Collections.Generic;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using System.Threading;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;

namespace ExceptionHandlingLoggingTests
{
    /// <summary>
    /// Summary description for LoggingThreadingTestFixture
    /// </summary>
    [TestClass]
    public class LoggingThreadingTestFixture
    {
        int count = 0;
        int noOfThreads = 100;
        private DictionaryConfigurationSource configSource;
        public LoggingThreadingTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }
        [TestInitialize()]
        public void Initialize()
        {
            //  TODO: Add test initialization code

            DictionarySourceLogging sourceSection = new DictionarySourceLogging();
            configSource = sourceSection.BuildDictionarySourceSection();
        }
        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void MutipleThreadLoggingDicTest()
        {
            Thread[] exThread = new Thread[noOfThreads];
            for (int i = 0; i < noOfThreads; i++)
            {
                exThread[i] = new Thread(new ThreadStart(RaiseException));
                exThread[i].IsBackground = true;
                exThread[i].Name = (i + 1).ToString();
                exThread[i].Start();
            }
            
            while (count != noOfThreads)
            {
            }
            Assert.AreEqual(noOfThreads, count);
        }

        public void RaiseException()
        {
            Exception originalException = new System.Security.SecurityException("DB Concurrency Exception");
            bool rethrow = false;
            
            rethrow = ExceptionPolicy.HandleException(originalException, "Wrap And Log To File SystemCategory");
            
            Assert.IsFalse(rethrow);
            count++;
        }
    }
}
