using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.Specialized;
using System.Collections;
using Microsoft.Win32; 
using Microsoft.Practices.EnterpriseLibrary.Logging;
using Microsoft.Practices.EnterpriseLibrary.Logging.TraceListeners;
using Microsoft.Practices.EnterpriseLibrary.Logging.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration; 
 
namespace CustomClasses
{
    [ConfigurationElementType(typeof(CustomTraceListenerData))]  
    public class CustomRegistryListener: CustomTraceListener
    {
        public CustomRegistryListener():base()
        {
        }

        public CustomRegistryListener(string initializeData)
            : base()
        {
        }

        public override void TraceData(System.Diagnostics.TraceEventCache eventCache, string source, System.Diagnostics.TraceEventType eventType, int id, object data)
        {
            string log;
            if (data is LogEntry)
            {
                log = this.Formatter.Format(data as LogEntry);
            }
            else
            {
                log = (string)data;
            }
            string keyvalue = "";
            string paramvalue = "";
            foreach (System.Collections.DictionaryEntry attribute in Attributes)
            {
                if (attribute.Key.ToString().Equals("regkey")) keyvalue  = attribute.Value.ToString() ;
                if (attribute.Key.ToString().Equals("regname")) paramvalue  = attribute.Value.ToString();

            }
            RegistryKey key = Registry.LocalMachine.OpenSubKey(keyvalue,true);
            if (key == null)
            {
               key = Registry.LocalMachine.CreateSubKey(keyvalue);
            }
            key.SetValue(paramvalue, log);
            key.Close(); 
        }

        public override void Write(string message)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public override void WriteLine(string message)
        {
            throw new Exception("The method or operation is not implemented.");
        }
    }
}
