using System;
using System.Text;
using System.Collections.Generic;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using Microsoft.Practices.EnterpriseLibrary.Security.AzMan.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Security;
using Microsoft.Practices.EnterpriseLibrary.Security.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace SecurityAzManFuncTests
{
    /// <summary>
    /// Summary description for AzManConfigurationTestFixture
    /// </summary>
    [TestClass]
    public class AzManConfigurationTestFixture
    {
        public AzManConfigurationTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        [TestMethod]
        public void AzManStoreLocationWithRelativePathTest()
        {
            SecurityConfigurationView configView = new SecurityConfigurationView(new SystemConfigurationSource());
            SecuritySettings settings= configView.GetSecuritySettings();
            AzManAuthorizationProviderData authData = (AzManAuthorizationProviderData)settings.AuthorizationProviders.Get("XMlStorageInRelativePathAzManProvider");
            if (authData.StoreLocation.Contains("{currentPath}"))
            {
                Assert.Fail();
            }
            
        }

        [TestMethod]
        public void AzManSetConfigurationPathWithRelativePathTest()
        {
   
            AzManAuthorizationProviderData authData = new AzManAuthorizationProviderData();
            authData.StoreLocation = "msxml://{currentPath}/AzManFuncTestsConfig.xml";
            if (!authData.StoreLocation.Contains("{currentPath}"))
            {
                Assert.Fail();
            }

        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion


    }
}
