using System;
using System.Text;
using System.Collections.Generic;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using System.Configuration;
using System.Security.Principal;
using Microsoft.Practices.EnterpriseLibrary.Common;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.EnterpriseLibrary.Security;
using Microsoft.Practices.EnterpriseLibrary.Security.Configuration;

namespace SecurityAzManFuncTests
{
    /// <summary>
    /// Summary description for AzManObjectCreationDictTestFixture
    /// </summary>
    [TestClass]
    public class AzManObjectCreationDictTestFixture
    {
        private DictionaryConfigurationSource configSource;
        public AzManObjectCreationDictTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestInitialize()]
        public void MyTestInitialize()
        {
            AzmanDictSource sourceSection = new AzmanDictSource();
            configSource = sourceSection.BuildDictionarySourceSection();


        }

        [TestMethod]
        public void CreateNamedAzmanInConfigFileDicTest()
        {
            AuthorizationProviderFactory authFactory = new AuthorizationProviderFactory(configSource);
            AuthorizationProvider azManProvider = authFactory.Create("DefaultAzManProviderDic") as AuthorizationProvider;
            Assert.IsNotNull(azManProvider);
        }
        [TestMethod]
        public void CreateDefaultAzmanFromConfigFileDicTest()
        {
            AuthorizationProviderFactory authFactory = new AuthorizationProviderFactory(configSource);
            AuthorizationProvider azManProvider = authFactory.CreateDefault() as AuthorizationProvider;
            Assert.IsNotNull(azManProvider);

        }

        [TestMethod]
        [ExpectedException(typeof(ConfigurationErrorsException))]
        public void CreateInvalidAzmanFromConfigFileDicTest()
        {
            AuthorizationProviderFactory authFactory = new AuthorizationProviderFactory(configSource);
            AuthorizationProvider azManProvider = authFactory.Create("InvalidProvider") as AuthorizationProvider;
        }
    }
}
