using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Instrumentation.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Security;
using Microsoft.Practices.EnterpriseLibrary.Security.Configuration;
using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Security.AzMan;
using Microsoft.Practices.EnterpriseLibrary.Security.AzMan.Configuration;

namespace SecurityAzManFuncTests
{
    public class AzmanDictSource
    {
        public DictionaryConfigurationSource BuildDictionarySourceSection()
        {
            DictionaryConfigurationSource section = new DictionaryConfigurationSource();

            #region "Security Configuration"
            SecuritySettings secSettings = new SecuritySettings();
            secSettings.DefaultAuthorizationProviderName = "DefaultAzManProviderDic";
            AzManAuthorizationProviderData arpd = new AzManAuthorizationProviderData();
            arpd.Application = "SecurityAzManFuncTests";
            arpd.StoreLocation = "msxml://{currentPath}//AzManFuncTestsConfig.xml";
            arpd.Type = Type.GetType("Microsoft.Practices.EnterpriseLibrary.Security.AzMan.AzManAuthorizationProvider, Microsoft.Practices.EnterpriseLibrary.Security.AzMan");
            arpd.AuditIdentifierPrefix = "";
            arpd.Scope = "";
            arpd.Name = "DefaultAzManProviderDic";

            secSettings.AuthorizationProviders.Add(arpd);

            section.Add("securityConfiguration", secSettings);
            #endregion
            InstrumentationConfigurationSection ics = new InstrumentationConfigurationSection(true, true, true);
            section.Add("instrumentationConfiguration", ics);
            return section;
        }

    }
}
