using System;
using System.Text;
using System.Collections.Generic;
using System.Configuration;
using System.Security.Principal;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using Microsoft.Practices.EnterpriseLibrary.Security;
using Microsoft.Practices.EnterpriseLibrary.Security.Configuration;

namespace SecurityCachingFuncTests
{
    /// <summary>
    /// Summary description for SecurityCachingObjectCreationTestFixture
    /// </summary>
    [TestClass]
    public class SecurityCachingObjectCreationTestFixture
    {
        public SecurityCachingObjectCreationTestFixture()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void CreateNamedSecurityCacheInConfigFile()
        {
            ISecurityCacheProvider cacheProvider = SecurityCacheFactory.GetSecurityCacheProvider("CacheProvider");
            Assert.IsNotNull(cacheProvider);
        }
        [TestMethod]
        public void CreateDefaultSecurityCacheFromConfigFile()
        {
            ISecurityCacheProvider cacheProvider = SecurityCacheFactory.GetSecurityCacheProvider();
            Assert.IsNotNull(cacheProvider);

        }

        [TestMethod]
        public void CreateCustomSecurityCache()
        {
            SecurityCacheProviderFactory factory = new SecurityCacheProviderFactory(new SecurityCachingDictSource().BuildDictionarySourceSection());
            ISecurityCacheProvider cacheProvider = factory.Create("MyCache");  
            Assert.IsNotNull(cacheProvider);
        }

        [TestMethod]
        [ExpectedException(typeof(ConfigurationErrorsException))]
        public void CreateInvalidSecurityCacheFromConfigFile()
        {
            ISecurityCacheProvider cacheProvider = SecurityCacheFactory.GetSecurityCacheProvider("InvalidProvider");
            


        }
    }
}
