using System;
//using Microsoft.VisualStudio.TestTools.UnitTesting;
#if !NUNIT
using Microsoft.VisualStudio.TestTools.UnitTesting;
#else
using NUnit.Framework;
using TestClass = NUnit.Framework.TestFixtureAttribute;
using TestInitialize = NUnit.Framework.SetUpAttribute;
using TestCleanup = NUnit.Framework.TearDownAttribute;
using TestMethod = NUnit.Framework.TestAttribute;
#endif
using Microsoft.Practices.EnterpriseLibrary.Data;
using Microsoft.Practices.EnterpriseLibrary.Data.Sql;
using System.Data;
using System.Data.SqlClient;
using System.Text;
using System.Data.Common;
using System.Configuration;
namespace DataFuncTests.SqlDatabaseFixtures
{
    /// <summary>
    /// Tests the UpdatesetMethod of the Database class
    /// </summary>
    [TestClass]
    public class UpdateDatasetTestFixture
    {
        string ItemsXMLfile;
        string ItemsUpdateXml;
        string ItemLDSctspparamXML;
        string ConnStr;
        public UpdateDatasetTestFixture()
        {
        }
        /// <summary>
        /// Initialize() is called once during test execution before
        /// test methods in this test class are executed.
        /// </summary>
        [TestInitialize()]
        public void Initialize()
        {
            ItemsXMLfile = "Items.xml";
            ItemsUpdateXml = "updateItems.xml";
            ItemLDSctspparamXML = "LDSctspparam.xml";
            ConnStr = ConfigurationManager.ConnectionStrings["DataSQLTest"].ConnectionString;
            ConnStr = ConfigurationManager.ConnectionStrings["DataSQLTest"].ConnectionString;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("begin Delete from Items " +
                "INSERT INTO [Items] ([ItemID],[ItemDescription],[Price],[QtyinHand],[QtyRequired]) VALUES (1, 'Digital Image Pro',38.95,25, 100) " +
    "INSERT INTO [Items] ([ItemID],[ItemDescription],[Price],[QtyinHand],[QtyRequired]) VALUES (2, 'Excel 2003', 98.95, 95, 100) "  +
    "INSERT INTO [Items] ([ItemID],[ItemDescription],[Price],[QtyinHand],[QtyRequired]) VALUES (3, 'Infopath', 89, 34, 100)" +                                                   
                                                   "delete from CustomersOrders where CustomerId > 3 " +
                                                   "Update CustomersOrders set QtyOrdered=100 " +
                                            "end", conn);
            //"Update Items set ItemDescription='Digital Image Pro',QtyInHand = 25, QtyRequired=100 where ItemId = 1 " +
            //                                       "Update Items set ItemDescription='Excel 2003',QtyInHand = 95, QtyRequired=100 where ItemId = 2 " +
            //                                       "Update Items set ItemDescription='Infopath',QtyInHand = 34, QtyRequired=100 where ItemId = 3 " +
            SqlDataReader dr = cmd.ExecuteReader();
            dr.Close();
            conn.Close();
        }
        /// <summary>
        /// Cleanup() is called once during test execution after
        /// test methods in this class have executed unless the
        /// corresponding Initialize() call threw an exception.
        /// </summary>
        [TestCleanup()]
        public void Cleanup()
        {
            //  TODO: Add test cleanup code
        }
        #region "UpdateDatasetWrapperDatasetStringSqlTest-sql,transCommit,transRollback"
        [TestMethod]
        public void UpdDSCmdSqlTransactionalBehaviouralTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "Select * from Items order by ItemID";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            // Establish our Insert, Delete, and Update commands
            // DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlTransactionalBehaviouralFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "Select * from Items order by ItemID";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);

            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "Select * from Items order by ItemID";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "Select * from Items order by ItemID";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //   table.Rows.Add(new object[] { 5, "Hello", 8, 99, 100 });
            //   table.Rows.Add(new object[] { 6, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlTransCommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "Select * from Items order by ItemID";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Digital Image Pro";
            //Delete a product
            table.Rows[3].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlTransRollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "Select * from Items order by ItemID";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //add a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                ItemDataSet.RejectChanges();
                connection.Close();
            }
            int index = 0;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            SqlConnection conn = new SqlConnection();
            StringBuilder readerDataExpected = new StringBuilder();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
        }
        #endregion

        #region "UpdateDatasetWrapperDatasetStringSpTest-sp,transcommit"
        [TestMethod]
        public void UpdDSCmdSpTransactionalBehaviouralTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //add a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpTransactionalBehaviouralFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //    table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //   table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            // Submit the DataSet, capturing the number of rows that were affected
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            try
            {
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpTransCommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(sqlCommand);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Digital Image Pro";
            //Delete a product
            table.Rows[3].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        #endregion

        #region "UpdateDatasetWrapperDatasetStringTrans-sql,commit&rollback"
        [TestMethod]
        public void UpdDSCmdSqlTransCommitTransactionalBehaviouralTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "begin Insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = ItemDataSet.Tables[ItemsTable];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlTransCommitTransactionalBehaviouralFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "begin Insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlTransCommitContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "begin Insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // insertCommandWrapper.AddInParameter("@QtyRequired", DbType.Int32, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlTransCommitStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "begin Insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //    table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //    table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
       
        #endregion

        #region "UpdateDatasetWrapperDatasetStringTrans-sp,commit&rollback
        [TestMethod]
        public void UpdDSCmdSpTransCommitTransactionalBehaviouralTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string spName = "AddrowSelect";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            string ItemsTable = "Items";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = ItemDataSet.Tables[ItemsTable];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpTransCommitTransactionalBehaviouralFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string spName = "AddrowSelect";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            string ItemsTable = "Items";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpTransCommitStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string spName = "AddrowSelect";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            string ItemsTable = "Items";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //      table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //    table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpTransCommitContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string spName = "AddrowSelect";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            string ItemsTable = "Items";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpTransRollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string spName = "AddrowSelect";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            string ItemsTable = "Items";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = ItemDataSet.Tables[ItemsTable];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        #endregion

        #region "UpdateDatasetWrapperDataset-behavioural,commit,rollback"
        [TestMethod]
        public void UpdDSCmdSPBehaviouralTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSPBehaviouralTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception)
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSPBehaviouralStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //    table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //    table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception)
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSPBehaviouralContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSPTransCommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSPTransRollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "ItemsGet";
            DbCommand dbCommandWrapper = db.GetStoredProcCommand(spName);
            db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
        }
        [TestMethod]
        public void UpdDSCmdSPRollbackTransactionBehaviouralTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string sqlCommand = "begin insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" }, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSPRollbackTransactionTranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string sqlCommand = "begin insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" }, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                // insertCommandWrapper.AddInParameter("@QtyRequired", DbType.Int32, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSPRollbackTransactionTransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string sqlCommand = "begin insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" }, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
        }
        #endregion

        #region "UpdateDatasetWrapperDatasetCTransaction-behavioural,commit,rollback"
        [TestMethod]
        public void UpdDSSqlCmdBehaviouralTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string sqlCommand = "begin insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" }, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            // insertCommandWrapper.AddInParameter("@ItemID", DbType.Int32, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSqlCmdBehaviouralTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string sqlCommand = "begin insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" }, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            //  updateCommandWrapper.AddInParameter("@ItemDescription", DbType.String, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception)
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSqlCmdBehaviouralStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string sqlCommand = "begin insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" }, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //   table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //   table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception)
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSqlCmdBehaviouralContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string sqlCommand = "begin insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" }, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSqlCmdTranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string sqlCommand = "begin insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" }, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSqlCmdTransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string sqlCommand = "begin insert into Items values(4, 'Infotech', 88, 35, 100) Select * from Items order by ItemID end";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(dbCommandWrapper, itemDataSet, new string[] { "Items" }, transaction);
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
            SqlConnection delconn = new SqlConnection();
            delconn.ConnectionString = ConnStr;
            delconn.Open();
            SqlCommand delcmd = new SqlCommand("Delete from Items where ItemID=4", delconn);
            delcmd.ExecuteNonQuery();
            delconn.Close();
        }
        #endregion

        #region "UpdateDataSetSpDatasetParam"
        [TestMethod]
        public void UpdDSSpCmdParamBehaviouralTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            db.LoadDataSet(spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpCmdParamBehaviouralTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            db.LoadDataSet(spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception)
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpCmdParamBehaviouralStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            db.LoadDataSet(spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //  table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //   table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpCmdParamBehaviouralContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            db.LoadDataSet(spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            //  updateCommandWrapper.AddInParameter("@ItemDescription", DbType.String, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpCmdParamTranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            db.LoadDataSet(spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpCmdParamTransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            db.LoadDataSet(spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
            conn.Close();
            SqlConnection delconn = new SqlConnection();
            delconn.ConnectionString = ConnStr;
            delconn.Open();
            SqlCommand delcmd = new SqlCommand("Delete from Items where ItemID=4", delconn);
            delcmd.ExecuteNonQuery();
            delconn.Close();
        }
        #endregion

        #region "UpdateDataSetCTransSpDatasetParam"
        [TestMethod]
        public void UpdDSSpParamCommitBehaviouralTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpParamCommitBehaviouralTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception)
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpParamCommitBehaviouralContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpParamCommitBehaviouralStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //     table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //      table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpParamCommittranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpParamCommittransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
            SqlConnection delconn = new SqlConnection();
            delconn.ConnectionString = ConnStr;
            delconn.Open();
            SqlCommand delcmd = new SqlCommand("Delete from Items where ItemID=4", delconn);
            delcmd.ExecuteNonQuery();
            delconn.Close();
        }
        [TestMethod]
        public void UpdDSSpParamRollbackTransactionalBehaviouralTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpParamRollbackTranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSSpParamRollbackTransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            string spName = "Addparams";
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, spName, itemDataSet, new string[] { "Items" }, new object[] { 4, "Infotech", 88, 35, 100 });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
        }
        #endregion

        #region "Updatedataset commandtype(sql),string,dataset,,object[]-behaviuor,commit,rollback"
        [TestMethod]
        public void UpdDSCmdSqlBehaviouralTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.Text, "begin Insert into Items values(4,'infotech',88,35,100)Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlBehaviouralTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.Text, "begin Insert into Items values(4,'infotech',88,35,100)Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception)
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlBehaviouralContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.Text, "begin Insert into Items values(4,'infotech',88,35,100)Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlBehaviouralStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100)Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //  table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //  table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }

        [TestMethod]
        public void UpdDSCmdSqlTranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.Text, "begin Insert into Items values(4,'infotech',88,35,100)Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
               #endregion

        #region "updatedataset-cmdtype(sp),string,dataset,-behaviour,commit,rollback"
        [TestMethod]
        public void UpdDSCmdSpBehaviouralTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpBehaviouralTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpBehaviouralStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //  table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpBehaviouralContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpTranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpTransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            db.LoadDataSet(CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
            SqlConnection delconn = new SqlConnection();
            delconn.ConnectionString = ConnStr;
            delconn.Open();
            SqlCommand delcmd = new SqlCommand("Delete from Items where ItemID=4", delconn);
            delcmd.ExecuteNonQuery();
            delconn.Close();
        }
        #endregion

        #region "updatedataset-trans(commit),cmdtype(sql),string,dataset,-behaviuor,commit,rollback"
        [TestMethod]
        public void UpdDSCmdSqlCommitBehaviouralTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlCommitBehaviouralTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlCommitBehaviouralStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //  table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //  table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands            
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlCommitBehaviouralContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlCommitTranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlCommitTransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
            SqlConnection delconn = new SqlConnection();
            delconn.ConnectionString = ConnStr;
            delconn.Open();
            SqlCommand delcmd = new SqlCommand("Delete from Items where ItemID=4", delconn);
            delcmd.ExecuteNonQuery();
            delconn.Close();
        }
        #endregion
        #region "Updatedataset-trans(roll),cmdtype(sql),string,dataset,-behaviour,rollback,commit"
        [TestMethod]
        public void UpdDSCmdSqlRollbackBehaviouralTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlRollbackBehaviouralTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlRollbackBehaviouralStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //  table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //  table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;//ds.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlRollbackBehaviouralContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlRollbackTranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSqlRollbackTransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.Text, "begin Insert into Items values(4,'Infotech',88,35,100) Select * from Items order by ItemID end", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
        }
        #endregion

        #region "Updatedataset-trans(comm),cmdtype(sp),string,dataset,-behaviour,rollback,commit"
        [TestMethod]
        public void UpdDSCmdSpCommitBehaviourTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpCommitBehaviourTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpCommitBehaviourStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //   table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //   table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpCommitBehaviourContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpCommittranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdDSCmdSpCommittransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Commit();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[3].Delete();
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
            conn.Close();
            SqlConnection delconn = new SqlConnection();
            delconn.ConnectionString = ConnStr;
            delconn.Open();
            SqlCommand delcmd = new SqlCommand("Delete from Items where ItemID=4", delconn);
            delcmd.ExecuteNonQuery();
            delconn.Close();
        }
        #endregion

        #region "Updatedataset-trans(roll),cmdtype(sp),string,dataset,-behaviour,rollback,commit"
        [TestMethod]
        public void UpdCmdSpRollbackBehaviouralTransactionalTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
            this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, UpdateBehavior.Transactional);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdCmdSpRollbackBehaviouralTransactionalFailTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemID"] = 4;
            // Establish our Insert, Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Transactional);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdCmdSpRollbackBehaviouralStandardTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //add a row
            table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            //   table.Rows.Add(new object[] { 4, "Hello", 8, 99, 100 });
            //   table.Rows.Add(new object[] { 5, "fifth", 88, 99, 100 });
            // Establish our Insert commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            try
            {
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, null, null, UpdateBehavior.Standard);
            }
            catch (Exception )
            {
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemLDSctspparamXML);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdCmdSpRollbackBehaviouralContinueTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            //Insert a row
            DataRow addedRow = table.Rows.Add(new object[] { 3, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            // Establish our Insert, Delete, and Update commands
            DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
            this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
            DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
            this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
            // Submit the DataSet, capturing the number of rows that were affected
            int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, null, UpdateBehavior.Continue);
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdCmdSpRollbacktranscommitTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsUpdateXml);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        [TestMethod]
        public void UpdCmdSpRollbacktransrollbackTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet itemDataSet = new DataSet();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                db.LoadDataSet(transaction, CommandType.StoredProcedure, "AddrowSelect", itemDataSet, new string[] { "Items" });
                transaction.Rollback();
                connection.Close();
            }
            DataTable table = itemDataSet.Tables["Items"];
            DataRow addedRow = table.Rows.Add(new object[] { 5, "Infotech", 88, 35, 100 });
            table.Rows[0]["ItemDescription"] = "Notinfotech";
            //Delete a product
            table.Rows[4].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommand("AddItem");
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@Price", DbType.Currency, ParameterDirection.Input, "Price", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyinHand", DbType.Int32, ParameterDirection.Input, "QtyinHand", DataRowVersion.Current);
                this.CreateCommandParameter(db, insertCommandWrapper, "@QtyRequired", DbType.Int32, ParameterDirection.Input, "QtyRequired", DataRowVersion.Current);
                DbCommand deleteCommandWrapper = db.GetStoredProcCommand("deleteitem");
                this.CreateCommandParameter(db, deleteCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                DbCommand updateCommandWrapper = db.GetStoredProcCommand("UpdateItem");
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemID", DbType.Int32, ParameterDirection.Input, "ItemID", DataRowVersion.Current);
                this.CreateCommandParameter(db, updateCommandWrapper, "@ItemDescription", DbType.String, ParameterDirection.Input, "ItemDescription", DataRowVersion.Current);
                // Submit the DataSet, capturing the number of rows that were affected
                int rowsAffected = db.UpdateDataSet(itemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Rollback();
                connection.Close();
            }
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            int index = 0;
            SqlConnection conn = new SqlConnection();
            conn.ConnectionString = ConnStr;
            conn.Open();
            SqlCommand cmd = new SqlCommand("select ItemDescription from Items ", conn);
            SqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                Assert.AreEqual(dr["ItemDescription"].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
                index++;
            }
            conn.Close();
        }
        #endregion
        [TestMethod]
        public void UsingGetStoredProcCommandWithSourceColumnsTest()
        {
            Database db = DatabaseFactory.CreateDatabase("DataSQLTest");
            DataSet ItemDataSet = new DataSet();
            string sqlCommand = "Select * from Items order by ItemID";
            DbCommand dbCommandWrapper = db.GetSqlStringCommand(sqlCommand);
            string ItemsTable = "Items";
            db.LoadDataSet(dbCommandWrapper, ItemDataSet, ItemsTable);
            DataTable table = ItemDataSet.Tables[ItemsTable];
            //add a row
            DataRow addedRow = table.Rows.Add(new object[] { 4, "Infotech", 88, 35, 100 });
            // Modify an existing product
            table.Rows[0]["ItemDescription"] = "Digital Image Pro";
            //Delete a product
            table.Rows[3].Delete();
            using (DbConnection connection = db.CreateConnection())
            {
                connection.Open();
                DbTransaction transaction = connection.BeginTransaction();
                // Establish our Insert, Delete, and Update commands
                DbCommand insertCommandWrapper = db.GetStoredProcCommandWithSourceColumns("AddItem", new string[] { "ItemID", "ItemDescription", "Price", "QtyinHand", "QtyRequired" });
                DbCommand deleteCommandWrapper = db.GetStoredProcCommandWithSourceColumns("deleteitem", new string[] { "ItemID" });
                DbCommand updateCommandWrapper = db.GetStoredProcCommandWithSourceColumns("UpdateItem", new string[] { "ItemID", "ItemDescription" });
                int rowsAffected = db.UpdateDataSet(ItemDataSet, "Items", insertCommandWrapper, updateCommandWrapper, deleteCommandWrapper, transaction);
                transaction.Commit();
                connection.Close();
            }
            int index;
            DataSet da = new DataSet();
            da.ReadXml(ItemsXMLfile);
            int count = da.Tables[0].Rows.Count;
            for (index = 0; index < count; index++)
            {
                Assert.AreEqual(table.Rows[index][1].ToString().Trim(), da.Tables[0].Rows[index][0].ToString().Trim());
            }
        }
        # region Helper Method
        private void CreateCommandParameter(Database db, DbCommand comm, string Parametername, DbType dbType, ParameterDirection dir, string SrcColumn, DataRowVersion rowVersion)
        {

            if (dir == ParameterDirection.Input)
            {
                db.AddInParameter(comm, Parametername, dbType, SrcColumn, rowVersion);
            }

            //DbParameter cmd = comm.CreateParameter();
            //cmd.ParameterName = Parametername;
            ////  cmd.Value = value;
            //cmd.SourceColumn = SrcColumn;
            //cmd.Direction = dir;
            //cmd.DbType = dbType;
            //cmd.SourceVersion = rowVersion;
            //return (cmd);
        }
        # endregion
    }
}
